<?xml version="1.0" encoding="ISO-8859-1"?>
<ncl id="tarea" xmlns="http://www.ncl.org.br/NCL3.0/EDTVProfile">

<head>

<regionBase>
	<!-- REGIONES EN ZINDEX 1 -->
	<region id="rgVideo" width="70%" height="60%" left="0%" top="0%" zIndex="1"/>
	
	<!-- REGIONES EN ZINDEX 2 -->
	<region id="rgLeft" width="30%" height="66%" right="0%" top="0%" zIndex="2"/>
	<region id="rgSearch" width="70%" height="8%" top="58.5%" left="0%" zIndex="2"/>
	<region id="rgTweet" width="100%" height="34%" bottom="0%" zIndex="2"/>	
	
	<!-- REGIONES EN ZINDEX 3 -->
	<region width="64%" height="8%" left="6%" top="58.5%" id="rgInput" zIndex="3"/>
	<region width="94%" height="27%" left="2%" bottom="4%" id="rgOutput" zIndex="3"/>
	
</regionBase>

<descriptorBase>
	<!-- DESCRIPTORES -->
	<descriptor id="dsVideo" region="rgVideo"/>
	
	<descriptor id="dsLeft" region="rgLeft"/>
	<descriptor id="dsSearch" region="rgSearch"/>
	<descriptor id="dsTweet" region="rgTweet"/>
	
	<descriptor id="dsInput"  region="rgInput" focusIndex="inputIdx"/>
	<descriptor id="dsOutput" region="rgOutput"/>

</descriptorBase>

<connectorBase>
	<!-- CONECTORES A UTILIZAR -->
	<causalConnector id="onBeginStart">
		<simpleCondition role="onBegin"/>
		<simpleAction role="start" max="unbounded" qualifier="par"/>
	</causalConnector>
	
	<causalConnector id="onBeginStop">
		<simpleCondition role="onBegin"/>
		<simpleAction role="stop" max="unbounded" qualifier="par"/>
	</causalConnector>
	
	<causalConnector id="onBeginSet">
		<connectorParam name="var"/>
		<simpleCondition role="onBegin"/>
		<simpleAction role="set" value="$var"/>
	</causalConnector>
	
	<causalConnector id="onEndAttributionSet">
		<connectorParam name="var"/>
		<simpleCondition role="onEndAttribution"/>
		<simpleAction role="set" value="$var"/>
	</causalConnector>
	
	<causalConnector id="onKeySelectionStart">
		<connectorParam name="keyCode"/>
		<simpleCondition role="onSelection" key="$keyCode"/>
		<simpleAction role="start" max="unbounded" qualifier="par"/>
	</causalConnector>
	
</connectorBase>

</head>

<body>
	<!-- PUNTO DE INICIO DE LA APLICACION -->
	<port id="P1" component="video"/>
	<port id="P2" component="left1"/>
	<port id="P3" component="red"/>
	<port id="P4" component="tweet"/>

	<!-- MEDIO QUE HACE POSIBLE ESCRIBIR POR CONTROL REMOTO -->
	<media type="application/x-ginga-settings" id="programSettings">
        <property name="service.currentKeyMaster" value="inputIdx"/>
	</media>

	<!-- SCRIPT LUA PARA ESCRIBIR POR CONTROL REMOTO -->
	<media id="input" src="win/input.lua"  descriptor="dsInput">
		<area id="select"/>
		<property name="text"/>
	</media>

	<!-- SCRIPT LUA QUE REALIZA LA PETICION HTML -->
	<media id="php" src="win/tweet.lua">
		<property name="search"/>
		<property name="result"/>
	</media>

	<!-- SCRIPT LUA QUE DESPLIEGA RESULTADOS POR PANTALLA -->
	<media id="output" src="win/output.lua" descriptor="dsOutput">
		<property name="text"/>
	</media>
	
	<!-- OTROS MEDIOS -->
	<media id="video" src="/media/video.mp4" descriptor="dsVideo"/>
	<media id="left1" src="/media/left1.jpg" descriptor="dsLeft"/>
	<media id="tweet" src="/media/bottom.jpg" descriptor="dsTweet"/>
	<media id="red" src="/media/red.jpg" descriptor="dsSearch"/>
	<media id="left2" src="/media/left2.jpg" descriptor="dsLeft"/>
	
	<!-- FUNCIONAMIENTO -->
	
	<!-- CUANDO SE SELECCIONA EL BOTON ROJO SE INICIA SCRIPT Y PANELES -->
	<link xconnector="onKeySelectionStart">
		<bind role="onSelection" component="video"/>
			<linkParam name="keyCode" value="RED"/>
		<bind role="start" component="left2"/>
		<bind role="start" component="input"/>
	</link>
	
	<!-- CUANDO SE INICIA EL SCRIPT DE ENTRADA SE INICIAN LOS DEMAS SCRIPTS -->
	<link xconnector="onBeginStart">
		<bind role="onBegin" component="input"/>
		<bind role="start"   component="php"/>
		<bind role="start"   component="output"/>
	</link>
	
	<!-- CUANDO SE CARGA EL SEGUNDO PANEL SE DETIENE EL PRIMERO -->
	<link xconnector="onBeginStop">
		<bind role="onBegin" component="left2"/>
		<bind role="stop"   component="left1"/>
	</link>

	<!-- CUANDO HAYA UN RESULTADO DE ENTRADA SE ENVIA AL SCRIPT DE BUSQUEDA -->
	<link xconnector="onBeginSet">
		<bind role="onBegin" component="input" interface="select"/>
		<bind role="set" component="php" interface="search">
			<bindParam name="var" value="$get"/>
		</bind>
		<bind role="get" component="input" interface="text"/>
	</link>
	
		<!-- CUANDO OBTIENE EL RESULTADO DE LA BUSQUEDA SE MUESTRA POR PANTALLA -->
	<link xconnector="onEndAttributionSet">
		<bind role="onEndAttribution" component="php" interface="result"/>
		<bind role="set" component="output" interface="text">
			<bindParam name="var" value="$get"/>
		</bind>
		<bind role="get" component="php" interface="result"/>
	</link>

</body>

</ncl>
